#!/bin/sh
# $Id: gethostinfo.sh,v 1.7 2012/05/29 00:55:47 sato Exp $
# $Name: SLINSVMCOVM-1_1_2-1 $

if [ $# -ne 4 ] ; then
    exit 2
fi

SSH_OPT1="StrictHostKeyChecking no"
SSH_OPT2="NumberOfPasswordPrompts 1"
ESXI_PROMPT="#"
PW_PROMPT="word:"
ESXI_IP="$2"
ESXI_ID="$3"
ESXI_PW="$4\r"
WAIT_TIME=1
RETRY_COUNT=3

if [ "$1" = "a" -o  "$1" = "p" ] ; then
    rm -f /var/fujitsu/SVmco/log/svfs/pcicardinfo_org
    expect -c "
    set timeout 5
    spawn ssh -o \"$SSH_OPT1\" -o \"$SSH_OPT2\" $ESXI_ID@$ESXI_IP /sbin/esxcli hardware pci list > /scratch/pcicardinfo_org
    expect $PW_PROMPT ; send $ESXI_PW
    expect $ESXI_PROMPT
    " >/dev/null 2>&1
    expect -c "
    set timeout 5
    spawn scp -o \"$SSH_OPT1\" -o \"$SSH_OPT2\" $ESXI_ID@$ESXI_IP:/scratch/pcicardinfo_org /var/fujitsu/SVmco/log/svfs/pcicardinfo_org
    expect $PW_PROMPT ; send $ESXI_PW
    expect $ESXI_PROMPT
    " >/dev/null 2>&1
    if [ ! -f /var/fujitsu/SVmco/log/svfs/pcicardinfo_org ] ; then
        exit 2
    fi
fi

if [ "$1" = "a" -o  "$1" = "l" ] ; then
    rm -f /var/fujitsu/SVmco/work/cmd/vmkernel.log
    expect -c "
    set timeout 5
    spawn scp -o \"$SSH_OPT1\" -o \"$SSH_OPT2\" $ESXI_ID@$ESXI_IP:/var/log/vmkernel.log /var/fujitsu/SVmco/work/cmd/vmkernel.log
    expect $PW_PROMPT ; send $ESXI_PW
    expect $ESXI_PROMPT
    " >/dev/null 2>&1
    if [ ! -f /var/fujitsu/SVmco/work/cmd/vmkernel.log ] ; then
        exit 2
    fi
fi

if [ "$1" = "a" -o  "$1" = "n" ] ; then
    rm -f /var/fujitsu/SVmco/log/svfs/nicinfo_org
    expect -c "
    set timeout 5
    spawn ssh -o \"$SSH_OPT1\" -o \"$SSH_OPT2\" $ESXI_ID@$ESXI_IP /sbin/esxcfg-nics -l > /scratch/nicinfo_org
    expect $PW_PROMPT ; send $ESXI_PW
    expect $ESXI_PROMPT
    " >/dev/null 2>&1
    expect -c "
    set timeout 5
    spawn scp -o \"$SSH_OPT1\" -o \"$SSH_OPT2\" $ESXI_ID@$ESXI_IP:/scratch/nicinfo_org /var/fujitsu/SVmco/log/svfs/nicinfo_org
    expect $PW_PROMPT ; send $ESXI_PW
    expect $ESXI_PROMPT
    " >/dev/null 2>&1
    if [ ! -f /var/fujitsu/SVmco/log/svfs/nicinfo_org ] ; then
        exit 2
    fi
fi

if [ "$1" = "r" ] ; then
    expect -c "
    set timeout 5
    spawn scp -o \"$SSH_OPT1\" -o \"$SSH_OPT2\" /opt/fujitsu/SVmco/bin/IPMISetSystemStatus $ESXI_ID@$ESXI_IP:/scratch/IPMISetSystemStatus
    expect $PW_PROMPT ; send $ESXI_PW
    expect $ESXI_PROMPT
    " >/dev/null 2>&1
    for var1 in `seq 0 $RETRY_COUNT`
    do
        rm -f /var/fujitsu/SVmco/work/cmd/Result
        expect -c "
        set timeout 5
        spawn ssh -o \"$SSH_OPT1\" -o \"$SSH_OPT2\" $ESXI_ID@$ESXI_IP /scratch/IPMISetSystemStatus R >/scratch/Result 2>&1
        expect $PW_PROMPT ; send $ESXI_PW
        expect $ESXI_PROMPT
        " >/dev/null 2>&1
        expect -c "
        set timeout 5
        spawn scp -o \"$SSH_OPT1\" -o \"$SSH_OPT2\" $ESXI_ID@$ESXI_IP:/scratch/Result /var/fujitsu/SVmco/work/cmd/Result
        expect $PW_PROMPT ; send $ESXI_PW
        expect $ESXI_PROMPT
        " >/dev/null 2>&1
        if [ -f /var/fujitsu/SVmco/work/cmd/Result ] ; then
            if [ `cat /var/fujitsu/SVmco/work/cmd/Result` -eq 0 ] ; then
                exit 0
            fi
        fi
        sleep $WAIT_TIME
    done
    if [ -f /var/fujitsu/SVmco/work/cmd/Result ] ; then
        exit `cat /var/fujitsu/SVmco/work/cmd/Result`
    else
        exit 2
    fi
fi

if [ "$1" = "s" ] ; then
    rm -f /var/fujitsu/SVmco/work/cmd/Result
    expect -c "
    set timeout 5
    spawn scp -o \"$SSH_OPT1\" -o \"$SSH_OPT2\" /opt/fujitsu/SVmco/bin/IPMISetSystemStatus $ESXI_ID@$ESXI_IP:/scratch/IPMISetSystemStatus
    expect $PW_PROMPT ; send $ESXI_PW
    expect $ESXI_PROMPT
    " >/dev/null 2>&1
    expect -c "
    set timeout 5
    spawn ssh -o \"$SSH_OPT1\" -o \"$SSH_OPT2\" $ESXI_ID@$ESXI_IP /scratch/IPMISetSystemStatus S >/scratch/Result 2>&1
    expect $PW_PROMPT ; send $ESXI_PW
    expect $ESXI_PROMPT
    " >/dev/null 2>&1
    expect -c "
    set timeout 5
    spawn scp -o \"$SSH_OPT1\" -o \"$SSH_OPT2\" $ESXI_ID@$ESXI_IP:/scratch/Result /var/fujitsu/SVmco/work/cmd/Result
    expect $PW_PROMPT ; send $ESXI_PW
    expect $ESXI_PROMPT
    " >/dev/null 2>&1
    if [ ! -f /var/fujitsu/SVmco/work/cmd/Result ] ; then
        exit 2
    fi
    exit `cat /var/fujitsu/SVmco/work/cmd/Result`
fi

exit 0
